/*
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class GetCountryCodeServlet extends HttpServlet {
   private static final long serialVersionUID = 1L;
   
   final String GEOAPIKEY = "IP2Location user key";
   final String PATHTODER = "path to .der file";
   final String KEYPAIRID ="CloudFront key pair ID";
   final String HTTPORHTTPS = "https";
   final String CFDISTRIBUTION = "dxxxx.cloudfront.net";
   final String CFPATH = "CloudFront URL for file";
   // date and time that CloudFront's signed URL expires, 
   // in Coordinated Universal Time
   final String EXPIRES = "2012-11-14T22:20:00.000Z";
   final String COUNTRYBLOCKED="VN";
   
   // This function will determine whether the end user have the permission to access the content or not
   // based on the country code return by end user's IP address
   protected void getIP(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
   
      PrintWriter out = response.getWriter();
      StringTokenizer st = null;
      String enduser_ip = null;
	    
	  // Retrieving end user's IP address from X-Forwarded-IP header
	  String headers = request.getHeader("X-FORWARDED-FOR");
	      
	  if (headers!= null){
	     st = new StringTokenizer(headers,",");
	         
	     while (st.hasMoreTokens()) {
	    	 enduser_ip = st.nextToken();
	     }
	  }
	      
	  // Retrieving the end user's IP address if X-Forwarded-IP header does not exist 
	      
	  if (enduser_ip == null) 
	    enduser_ip = request.getRemoteAddr();
          
      try {
         GetIP2LocationCountryCode country = new GetIP2LocationCountryCode(GEOAPIKEY, enduser_ip);
         
         if ( !country.getCountry().equalsIgnoreCase(COUNTRYBLOCKED)){
            
            SignedUrl myApp = new SignedUrl(KEYPAIRID,PATHTODER);
            System.out.println(myApp.getSignedHash(HTTPORHTTPS,CFDISTRIBUTION,CFPATH,EXPIRES));
         }else {
            System.out.println("Sorry, you do not have permission to access the content.");
         }
      } catch (Exception e1) {
         e1.printStackTrace();
      }
   }
}