/*
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;

public class GetIP2LocationCountryCode {

	private static String apiKey;
	private static String ip_address;
			
	GetIP2LocationCountryCode(String myapiKey, String ip){
		apiKey = myapiKey;
		ip_address = ip;
	}
	
	// This function will return country code by calling IP2Location web service after retrieving
	// end user's IP address
	public String getCountry() throws Exception {	    
	    // URL string for IP2Location web service
		String APIURL = "http://api.ip2location.com?ip="+ip_address+"&key="+apiKey;
		
		// Open connection to IP2Location Web Service
		URL url = new URL(APIURL);
		URLConnection urlConn = url.openConnection();

		urlConn.setUseCaches(false);

		InputStreamReader in = new InputStreamReader((InputStream) urlConn.getContent());
		BufferedReader buff = new BufferedReader(in);

		return buff.readLine();
	}
}